

#include <math.h>
#include <stdio.h>
#include <string.h>
#include <iostream>
#include <stdlib.h>
#include "GL/glew.c"
#include "GL/glut.h"
#include "tools/glslang.cpp"

#pragma comment(lib, "assimp.lib")

#include "Assimp/assimp.hpp"	
#include "Assimp/aiPostProcess.h"
#include "Assimp/aiScene.h"




#define PI 3.14159265

GLuint p;  //shader program

GLuint vao; //Vertex Array Object

GLuint fb, depth_tex; 

float angle = 0.0f;  //rotation angle

float *points = 0;
float *normals = 0;
unsigned int* indexArr = 0;
unsigned int index = 0;
unsigned int vertCnt = 0;
unsigned int faceCnt = 0;
GLuint gTrianglesIB = 0;
GLuint gPositionsVB = 0;
GLuint gNormalsVB = 0;
float* vPosArr = 0;



void loadScene(std::string name)
{
		std::string pFile = name; 
 
		// Create an instance of the Importer class
		Assimp::Importer importer;

		const aiScene* scene = importer.ReadFile( pFile, aiProcessPreset_TargetRealtime_Fast);

			// If the import failed, report it
		if(!scene)
		{
			printf("%s\n", importer.GetErrorString());
			return;
		}

		// generate VBOs
		aiMesh* tmpMesh = scene->mMeshes[0];
		

		// triangles array
		indexArr = (unsigned int *)malloc(sizeof(unsigned int) * tmpMesh->mNumFaces * 3);
		index = 0;
		vertCnt = 0;
		faceCnt = 0;

		for (unsigned int t = 0; t < tmpMesh->mNumFaces; ++t)
		{
			const struct aiFace* face = &tmpMesh->mFaces[t];

			memcpy(&indexArr[index], face->mIndices,3 * sizeof(unsigned int));
			index += 3;
		}
		faceCnt = tmpMesh->mNumFaces;

		// buffer for faces
		glGenBuffers(1, &gTrianglesIB);
		glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, gTrianglesIB);
		glBufferData(GL_ELEMENT_ARRAY_BUFFER, sizeof(unsigned int) * faceCnt* 3, indexArr, GL_STATIC_DRAW);

			// buffer for vertex positions
		if (tmpMesh->HasPositions())
		{
			// save position arrays for animation
			vPosArr = (float *)malloc(sizeof(float) * tmpMesh->mNumVertices * 3);
			index = 0;
			for (unsigned int t = 0; t < tmpMesh->mNumVertices; ++t)
			{
				memcpy(&vPosArr[index], &tmpMesh->mVertices[t], 3 * sizeof(float));
				index += 3;
			}
			vertCnt = tmpMesh->mNumVertices;

			glGenBuffers(1, &gPositionsVB);
			glBindBuffer(GL_ARRAY_BUFFER, gPositionsVB);
			glBufferData(GL_ARRAY_BUFFER, sizeof(float)*3*vertCnt, vPosArr, GL_STATIC_DRAW);
		}

		if (tmpMesh->HasNormals())
		{
			glGenBuffers(1, &gNormalsVB);
			glBindBuffer(GL_ARRAY_BUFFER, gNormalsVB);
			glBufferData(GL_ARRAY_BUFFER, sizeof(float)*3*vertCnt, tmpMesh->mNormals, GL_STATIC_DRAW);
		}
	}

void setFBO(){
	//32 bit depth texture, 256x256
  glGenTextures(1, &depth_tex);
  glBindTexture(GL_TEXTURE_2D, depth_tex);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
  glTexParameteri(GL_TEXTURE_2D, GL_DEPTH_TEXTURE_MODE, GL_INTENSITY);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_COMPARE_MODE, GL_COMPARE_R_TO_TEXTURE);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_COMPARE_FUNC, GL_LEQUAL);
  //NULL means reserve texture memory, but texels are undefined
  //You can also try GL_DEPTH_COMPONENT16, GL_DEPTH_COMPONENT24 for the internal format.
  //If GL_DEPTH24_STENCIL8_EXT, go ahead and use it (GL_EXT_packed_depth_stencil)
  glTexImage2D(GL_TEXTURE_2D, 0, GL_DEPTH_COMPONENT32, 256, 256, 0, GL_DEPTH_COMPONENT, GL_UNSIGNED_INT, NULL);
  //-------------------------
  glGenFramebuffersEXT(1, &fb);
  glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, fb);
  //Attach
  glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT, GL_DEPTH_ATTACHMENT_EXT, GL_TEXTURE_2D, depth_tex, 0);
}

//ToDo nastavte VAO
void setVertexArray(){
	//Vertex Array Object
	glGenVertexArrays (1, &vao);
	glBindVertexArray (vao);
	//glEnableVertexAttribArray (...);
	//...

}

void renderScene(void) {

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glUseProgram(p);


  //ToDo vykreslite scenu
	glBindVertexArray (vao);
	// draw points 0-3 from the currently bound VAO with current in-use shader
	//glDraw...

   glutSwapBuffers();
}

//ToDo venasobte matice 4x4
float* mutM4x4(float* m1, float * m2){

	float * m;
	m = new float[16]; 

	for(int i=0;i<4;i++)
		for(int j=0;j<4;j++){

				//......


		}


		return m;

}

//ToDo vynasobte matice 3x3
float* mutM3x3(float* m1, float * m2){

	float * m;
	m = new float[9]; 

	//....


		return m;

}

float* setIdentity4x4(){
	float * m;
	m = new float[16]; 


	m[0] = 1.0;	m[1] = 0.0;	m[2] = 0.0;	m[3] = 0.0;
	m[4] =0.0;	m[5] = 1.0;	m[6] = 0.0;	m[7] = 0.0;
	m[8] =0.0;	m[9] = 0.0;	m[10] = 1.0;	m[11] = 0.0;
	m[12] =0.0;	m[13] = 0.0;	m[14] =0.0;	m[15] = 1.0;


	return m;

}

//ToDo vytvorte skalovaciu maticu
float* setScale4x4(float x, float y, float z){
	float * m;
	m = new float[16]; 


//...

	return m;

}

//ToDo vytvorte maticu posunu
float* setTranslation4x4(float dx, float dy, float dz){
	float * m;
	m = new float[16]; 


//...

	return m;

}

//ToDo definujte rotacnu maticu 4x4
float* setRotation4x4(float x, float y, float z, float angle){
	float * m;
	m = new float[16]; 

	float c = cos(angle);
	float s = sin(angle);

  //http://www.cprogramming.com/tutorial/3d/rotation.html

	//...


	return m;
}

//ToDo definujte rotacnu maticu 3x3
float* setRotation3x3(float x, float y, float z, float angle){
	float * m;
	m = new float[9]; 
 //...

	return m;
}


float* setIdentity3x3(){

	float * m;
	m = new float[9]; 


	m[0] = 1.0;	m[1] = 0.0;	m[2] = 0.0;	
	m[3] = 0.0;	m[4] = 1.0;	m[5] = 0.0;	
	m[6] = 0.0;	m[7] = 0.0;	m[8] = 1.0;	



	return m;
}

float* setPerspective( float angle_of_view,
    float aspect_ratio,
    float z_near,
    float z_far){

	float * m;
	m = new float[16]; 

	//http://duriansoftware.com/joe/An-intro-to-modern-OpenGL.-Chapter-3:-3D-transformation-and-projection.html

	//ToDo nastavte projekcnu maicu

	return m;
}

float* setOrtho( float l, float r,
    float b, float t,
    float z_near,
    float z_far){

	float * m;
	m = new float[16]; 


	//ToDo nastavte rovnobezne premietania
	//http://www.songho.ca/opengl/gl_projectionmatrix.html

	return m;
}

int main(int argc, char **argv) {

	// init GLUT and create Window
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA);
	glutInitWindowPosition(100,100);
	glutInitWindowSize(512,512);
	glutCreateWindow("OpenGL");

	// init GLEW to support extensions
	glewInit();
	glEnable(GL_DEPTH_TEST);
	if (glewIsSupported("GL_VERSION_3_3"))
        printf("Ready for OpenGL 3.3\n");
    else {
        printf("OpenGL 3.3 not supported\n");
        exit(1);
    }

	p = createShaderProgram("./shaders/shader.vert", "./shaders/shader.geom", "./shaders/shader.frag");

	glUseProgram(p);
	

	loadScene("chobotnicka.dae");


	//This is the location of the L_pos uniform variable in our program
	int loc = glGetUniformLocation(p, "L_pos");
	glUniform3f(loc, 0.0, 0.0, 10.0);

	//This is the location of the L_pos uniform variable in our program
	loc = glGetUniformLocation(p, "diffuse_col");
	glUniform4f(loc, 1.0, 1.0, 0.0, 1.0);



	// set matrix with an array
	float * model_view_camera4x4 = setIdentity4x4();

	float * model_view_camera3x3 = setIdentity3x3();
	
	float * projection_camera = setFrustum((45.0f*PI/180.f), 1.0f, 0.01f, 100.0f);


  //ToDo nastavte pohlad na scenu


	//This is the location of the model_view_camera4x4 uniform variable in our program
	loc = glGetUniformLocation(p, "model_view_camera4x4");
	glUniformMatrix4fv(loc, 1, GL_FALSE,  model_view_camera4x4);


	//This is the location of the model_view_camera3x3 uniform variable in our program
	loc = glGetUniformLocation(p, "model_view_camera3x3");
	glUniformMatrix3fv(loc, 1, GL_FALSE,  model_view_camera3x3);


	//This is the location of the camera projection uniform variable in our program
	loc = glGetUniformLocation(p, "projection_camera");
	glUniformMatrix4fv(loc, 1, GL_FALSE, projection_camera);


	setVertexArray();

	// register callbacks
	glutDisplayFunc(renderScene);
	glutIdleFunc(renderScene);

	// enter GLUT event processing cycle
	glutMainLoop();
	
	return 1;
}