#version 400

layout(location = 0) in vec3 vertex_position;
layout(location = 1) in vec3 vertex_normal;

uniform mat4 model_view_camera4x4;
uniform mat3 model_view_camera3x3;
uniform mat4 projection_camera;



out VertexData {
    vec3 normal;
    vec4 ecPos;
} VertexOut;


void main () {




  VertexOut.normal = model_view_camera3x3 * vertex_normal;    

  //compute the vertex position  in camera space
  VertexOut.ecPos =  model_view_camera4x4 * vec4 (vertex_position, 1.0);


  gl_Position = projection_camera * VertexOut.ecPos;

}